package nc.bs.yp.impl;

import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.ArrayList;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import nc.bs.framework.adaptor.IHttpServletAdaptor;
import nc.bs.framework.common.InvocationInfoProxy;
import nc.bs.framework.common.NCLocator;
import nc.bs.framework.server.ISecurityTokenCallback;
import nc.bs.servlet.service.BaseServlet;
import nc.itf.mmpac.pickm.IPickmMaintainService;
import nc.itf.mmpac.pickm.dpickm.IDpickmMaintainService;
import nc.itf.mmpac.pickm.ppickm.IPpickmMaintainService;
import nc.itf.mmpac.pmo.pac0002.IPMOMaintainService;
import nc.log.NcLog;
import nc.md.persist.framework.IMDPersistenceQueryService;
import nc.vo.mmpac.pickm.entity.AggPickmVO;
import nc.vo.mmpac.pmo.pac0002.entity.PMOAggVO;
import nc.yp.dao.IUtilMaintain;
import nc.yp.dao.PomStatusMaintain;
import net.sf.json.JSONObject;

/**
 * ޸Ŀ״̬
 * @author LP
 *
 */
@SuppressWarnings("restriction")
public class PomUpdateStatusImpl extends BaseServlet implements IHttpServletAdaptor {
	
	private static final String TURE = "0";
	private static final String FALSE = "1";
	private IMDPersistenceQueryService qryService = NCLocator.getInstance().lookup(IMDPersistenceQueryService.class);
	private JSONObject p_data = null;

	@Override
	public void doAction(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		
		NCLocator.getInstance().lookup(ISecurityTokenCallback.class).token("NCSystem".getBytes(),"pfxx".getBytes());
        InvocationInfoProxy.getInstance().setUserDataSource("syptest210103");
		
        String vbillcode = "";
        String errorMessgae = "";
        JSONObject logObject = new JSONObject();
		String json = buildJson(req, resp, this.getClass().getName());
		PrintWriter out = resp.getWriter();

		try {
			
			p_data = JSONObject.fromObject(json);//ȡ
			
			logObject.accumulate("InputDate", p_data);
			
			vbillcode = p_data.getString("vbillcode");//ȡ
			
			checkJson();//ǿж
			
			PMOAggVO pmoAggVO = getPmoVO(vbillcode);//ȡAggVO
			
			approveUpdate(pmoAggVO);//״̬
			
			out.print(formatRSJsonData(TURE, p_data.getString("vbillcode"), "ɹ"));
			logObject.accumulate("OutDate", formatRSJsonData(TURE, p_data.getString("vbillcode"), "ɹ").toString());
			
		} catch (Exception e) {
			
			String error = e.getMessage()==null?e.toString():e.getMessage().toString();
			out.print(formatRSJsonData(FALSE, vbillcode, error));
			logObject.accumulate("OutDate",formatRSJsonData(FALSE, vbillcode, error).toString());
//			logObject.accumulate("ErrorMessage",StackTrace(e));
			errorMessgae = StackTrace(e);
			
		}finally {
			NcLog.info(logObject.toString()+"\r"+errorMessgae);
			out.flush();
			out.close();
		}
		
	}
	
	/*
	 * ǿж
	 */
	private void checkJson() throws Exception {
		
		StringBuffer mags = new StringBuffer();
		
		String vbillcode = "vbillcode";//
		String statusName = "statusName";//״̬
 
		String[] HeadKey = {vbillcode,statusName};
		
		for (String as : HeadKey) {

			if (p_data.getString(as).isEmpty()) {
				mags.append("'" + as + "'");
			}
		}
		
		if (mags.length()!=0) {
			throw new Exception("ֶβΪգ"+mags);
		}
	}
	
	/*
	 * ȡAggVO
	 */
	@SuppressWarnings("unchecked")
	private PMOAggVO getPmoVO(String vbillcode) throws Exception {
		
		ArrayList<PMOAggVO> PmoAggVOs = (ArrayList<PMOAggVO>) 
				qryService.queryBillOfVOByCond(PMOAggVO.class,"vbillcode = '"+vbillcode+"'",true,false);
		
		if (PmoAggVOs == null || PmoAggVOs.size() == 0) {
			throw new Exception("ݵݺ'"+vbillcode+"'δҵ飡");
		}else {
			PMOAggVO pmoAggVO = (PMOAggVO) PmoAggVOs.get(0).clone();
			return pmoAggVO;
		}
	}
	
	/*
	 * ȡϼƻAggVO
	 */
	@SuppressWarnings("unchecked")
	private AggPickmVO getPickmVO(String vfirstmocode) throws Exception {
		
		ArrayList<AggPickmVO> PickmAggVOs = (ArrayList<AggPickmVO>) 
				qryService.queryBillOfVOByCond(AggPickmVO.class,"vfirstmocode = '"+vfirstmocode+"'",true,false);
		
		AggPickmVO aggPickmVO = (AggPickmVO) PickmAggVOs.get(0).clone();
			return aggPickmVO;
	}
	
	/*
	 * ״̬
	 */
	private void approveUpdate(PMOAggVO pmoAggVO) throws Exception {
		
		if (p_data.getString("statusName").equals("")) {
			
			NCLocator.getInstance().lookup(IPMOMaintainService.class).approve(new PMOAggVO[] {pmoAggVO});
			
		}else if (p_data.getString("statusName").equals("ȡ")) {
			
			AggPickmVO aggPickmVO = getPickmVO(p_data.getString("vbillcode"));
			
			PomStatusMaintain pomStatusMaintain = NCLocator.getInstance().lookup(PomStatusMaintain.class);
			
			pomStatusMaintain.PomStatus_RequiresNew(aggPickmVO, pmoAggVO);
			
		}else {
			throw new Exception("status ֻд ' ' 'δ' ");
		}
		
	}
	
	/*
	 * 쳣Ϣϸ
	 */
	private String StackTrace(Exception e) {
	    StringWriter sw = new StringWriter();
	    PrintWriter pw = new PrintWriter(sw);
	    e.printStackTrace(pw);
	    return sw.toString();
	}
	
}
